SystemOrganization addCategory: #Granja!

TestCase subclass: #CerdoTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Granja'!

!CerdoTest methodsFor: 'as yet unclassified' stamp: 'Guidito 10/3/2012 19:43'!
testUnCerdoBebe
	|unCerdo|
	unCerdo := Cerdo new.
	unCerdo bebe.
	self deny: (unCerdo tieneSed).
	self assert: (unCerdo tieneHambre).
	
 ! !

!CerdoTest methodsFor: 'as yet unclassified' stamp: 'Guidito 10/3/2012 20:21'!
testUnCerdoCome
	|unCerdo|
	unCerdo := Cerdo new.
	unCerdo come: 0.199 .
	self assert: (unCerdo peso = 20).
	unCerdo come: 0.5 .
	self assert: (unCerdo peso = 20.5).
	unCerdo come: 1.5 .
	self deny:(unCerdo tieneHambre).
	! !

!CerdoTest methodsFor: 'as yet unclassified' stamp: 'Guidito 10/3/2012 19:44'!
testUnCerdoComeMasTresVecesSinBeber
	|unCerdo|
	unCerdo := Cerdo new.
	unCerdo bebe.
	unCerdo come:1.25.
	unCerdo come:4.2.
	unCerdo come:2.87.
	unCerdo come:2.87.
	self assert: (unCerdo tieneSed).

	
 ! !

!CerdoTest methodsFor: 'as yet unclassified' stamp: 'MartnPerazzo 10/2/2012 21:28'!
testUnCerdoComeVariasVeces
	|unCerdo|
	unCerdo := Cerdo new.
	unCerdo come: 0.199 .
	unCerdo come:0.25.
	unCerdo come:1.25.
	unCerdo come:4.2.
	unCerdo come:2.87.
	
	self assert: (unCerdo maximoComido = 4.2).
	
 ! !

!CerdoTest methodsFor: 'as yet unclassified' stamp: 'Guidito 10/3/2012 20:10'!
testVacunarAUnCerdo
	|unCerdo|
	unCerdo := Cerdo new.
	
	self assert: (unCerdo hayQueVacunar ).
	
 ! !

TestCase subclass: #GallinaTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Granja'!

!GallinaTest methodsFor: 'as yet unclassified' stamp: 'Guidito 10/2/2012 21:50'!
test01DadaUnaGallinaCuandoComeNoSeObservaNingunCambio
	| unaGallina |
	unaGallina := Gallina new.
	unaGallina come:10.
	self assert:(unaGallina cuantoPesa=4).	! !

!GallinaTest methodsFor: 'as yet unclassified' stamp: 'Guidito 10/2/2012 21:51'!
test02DadaUnaGallinaNuncaTieneSed
	| unaGallina |
	unaGallina := Gallina new.
	self deny:(unaGallina tieneSed).	! !

TestCase subclass: #VacaTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Granja'!

!VacaTest methodsFor: 'as yet unclassified' stamp: 'Guidito 10/3/2012 16:47'!
test01DadaUnaVacaCuandoComeAumentaElPesoYLeDaSed
	| unaVaca pesovaca comida |
	comida := 30.
	unaVaca := Vaca new.
	pesovaca := unaVaca peso.
	unaVaca come: comida.
	self assert: unaVaca peso equals: pesovaca + (comida / 3).
	self assert: unaVaca tieneSed.! !

!VacaTest methodsFor: 'as yet unclassified' stamp: 'Guidito 10/3/2012 19:52'!
test02DadaUnaVacaConSedCuandoBebeSeLeVaLaSedYPierde500g

|unaVacaConSed pesovaca |

unaVacaConSed := Vaca conSed.
pesovaca:= unaVacaConSed peso.
unaVacaConSed bebe.
self assert: unaVacaConSed peso equals: (pesovaca-0.5).
self deny: unaVacaConSed tieneSed.

! !

!VacaTest methodsFor: 'as yet unclassified' stamp: 'Guidito 10/3/2012 19:55'!
test03DadaUnaVacaVacunadaNoVacunarla

|unaVaca |
unaVaca := Vaca new.
unaVaca vacunar.
self deny: unaVaca hayQueVacunar.


! !

!VacaTest methodsFor: 'as yet unclassified' stamp: 'Guidito 10/3/2012 19:55'!
test04DadaUnaVacaNoVacunadaHayQueVacunarla
	| unaVaca |
	unaVaca := Vaca new.
	
	self assert: unaVaca hayQueVacunar.! !

!VacaTest methodsFor: 'as yet unclassified' stamp: 'Guidito 10/3/2012 16:24'!
test05DadaUnaVacaTieneHambreSiPesaMenosDe200
	| unaVaca pesovaca|
	unaVaca := Vaca new.
	
	pesovaca := unaVaca peso.
	self assert: pesovaca <200.
	self assert: unaVaca tieneHambre.
	
	 ! !

!VacaTest methodsFor: 'as yet unclassified' stamp: 'RU 10/2/2012 22:03'!
test06DadaUnaVacaCuandoCaminaPierde3kg
	| unaVaca pesovaca|
	unaVaca := Vaca new.
	
	pesovaca := unaVaca peso.
	unaVaca camina.
	self assert: unaVaca peso equals: pesovaca-3.
	
	 ! !

Object subclass: #Animal
	instanceVariableNames: 'peso'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Granja'!

!Animal methodsFor: 'as yet unclassified' stamp: 'Guidito 10/2/2012 21:50'!
come:unaCantidad
	^self subclassResponsibility.! !

!Animal methodsFor: 'as yet unclassified' stamp: 'MartnPerazzo 10/2/2012 21:08'!
hambre
	^hambre.! !

!Animal methodsFor: 'as yet unclassified' stamp: 'Guidito 10/3/2012 20:17'!
initialize
	peso:=0.! !

!Animal methodsFor: 'as yet unclassified' stamp: 'MartnPerazzo 10/2/2012 21:09'!
peso
	^peso.! !

!Animal methodsFor: 'as yet unclassified' stamp: 'MartnPerazzo 10/2/2012 21:09'!
sed
	^sed.! !

!Animal methodsFor: 'as yet unclassified' stamp: 'MartnPerazzo 10/2/2012 21:48'!
vacunado
	^vacunado.! !

Animal subclass: #Cerdo
	instanceVariableNames: 'necesidades cantidadComidas vecesQueComio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Granja'!

!Cerdo methodsFor: 'updating' stamp: 'Guidito 10/3/2012 19:34'!
bebe
	necesidades remove: Sed new.
	necesidades add: Hambre new.
	vecesQueComio:=0.! !

!Cerdo methodsFor: 'updating' stamp: 'Guidito 10/3/2012 20:40'!
come: unPeso 
     vecesQueComio:=vecesQueComio+1.
     vecesQueComio >3
     ifTrue: [necesidades add: Sed new].
     cantidadComidas add: unPeso .
     unPeso>= 0.2
     ifTrue: [ peso:=peso+unPeso].
     unPeso> 1
     ifTrue: [necesidades remove: Hambre new ifAbsent: ["Ya no tiene hambre, no tengo nada que sacar"]]. 
     
 ! !

!Cerdo methodsFor: 'evaluating' stamp: 'Guidito 10/3/2012 20:10'!
hayQueVacunar
	^(necesidades includes:Vacunar new).! !

!Cerdo methodsFor: 'evaluating' stamp: 'Guidito 10/3/2012 19:36'!
historialOrdenadoDeComidas
	^ cantidadComidas asSortedCollection: [ :peso1 :peso2 | peso1 > peso2 ]! !

!Cerdo methodsFor: 'as yet unclassified' stamp: 'Guidito 10/3/2012 20:22'!
initialize
	super initialize.
	peso:=20.
	necesidades:= Set new
					add: Sed new;
					add: Hambre new;
					add: Vacunar new;
					yourself.
	cantidadComidas:= OrderedCollection   new.
	vecesQueComio :=0.! !

!Cerdo methodsFor: 'evaluating' stamp: 'MartnPerazzo 10/2/2012 21:46'!
maximoComido
	^self historialOrdenadoDeComidas first.! !

!Cerdo methodsFor: 'evaluating' stamp: 'Guidito 10/3/2012 19:44'!
tieneHambre
  ^(necesidades includes:Hambre new).! !

!Cerdo methodsFor: 'evaluating' stamp: 'Guidito 10/3/2012 19:43'!
tieneSed
  ^(necesidades includes:Sed new).! !

Animal subclass: #Gallina
	instanceVariableNames: 'necesidades cantidadComidas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Granja'!

!Gallina methodsFor: 'as yet unclassified' stamp: 'Guidito 10/2/2012 21:49'!
come: unaCantidad
	cantidadComidas add: unaCantidad.! !

!Gallina methodsFor: 'as yet unclassified' stamp: 'Guidito 10/2/2012 21:51'!
cuantoComio
	^cantidadComidas size.! !

!Gallina methodsFor: 'as yet unclassified' stamp: 'Guidito 10/2/2012 21:33'!
cuantoPesa
	^peso.! !

!Gallina methodsFor: 'as yet unclassified' stamp: 'Guidito 10/3/2012 20:18'!
initialize
	super initialize.
	necesidades := Set new
		add: Hambre new;
		yourself.
	peso := 4.
	cantidadComidas := OrderedCollection new.! !

!Gallina methodsFor: 'as yet unclassified' stamp: 'Guidito 10/2/2012 21:49'!
tieneSed
	^false.! !

Animal subclass: #Vaca
	instanceVariableNames: 'necesidades'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Granja'!

!Vaca class methodsFor: 'as yet unclassified' stamp: 'Guidito 10/3/2012 16:59'!
conSed
	^self new inicializarCon: Sed.! !

!Vaca methodsFor: 'as yet unclassified' stamp: 'Guidito 10/3/2012 17:04'!
bebe
  peso:= peso-0.5.
  necesidades remove: (Sed new).
  ! !

!Vaca methodsFor: 'as yet unclassified' stamp: 'RU 10/2/2012 22:02'!
camina
  peso:= peso - 3.! !

!Vaca methodsFor: 'as yet unclassified' stamp: 'Guidito 10/3/2012 17:06'!
come: pesocomida
	peso:=peso+(pesocomida/3).
	necesidades add: (Sed new).
	! !

!Vaca methodsFor: 'as yet unclassified' stamp: 'Guidito 10/3/2012 19:55'!
hayQueVacunar
	^(necesidades includes:Vacunar new).! !

!Vaca methodsFor: 'as yet unclassified' stamp: 'Guidito 10/3/2012 20:02'!
inicializarCon: unaNecesidad
peso:= 101.
necesidades := Set new
				add: Vacunar new;
				add: unaNecesidad new;
				yourself.! !

!Vaca methodsFor: 'as yet unclassified' stamp: 'Guidito 10/3/2012 20:18'!
initialize 
	super initialize.
	peso:= 101.
	necesidades := Set new
					add: Vacunar new;
					yourself.! !

!Vaca methodsFor: 'as yet unclassified' stamp: 'Guidito 10/3/2012 13:40'!
peso
	^peso! !

!Vaca methodsFor: 'as yet unclassified' stamp: 'Guidito 10/3/2012 16:24'!
tieneHambre
 	^true! !

!Vaca methodsFor: 'as yet unclassified' stamp: 'Guidito 10/3/2012 16:51'!
tieneSed
  ^(necesidades includes:Sed new).! !

!Vaca methodsFor: 'as yet unclassified' stamp: 'Guidito 10/3/2012 13:41'!
vacunar
	necesidades remove: Vacunar new.! !

Object subclass: #Necesidad
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Granja'!

Necesidad subclass: #Hambre
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Granja'!

Hambre class
	instanceVariableNames: 'instance'!

Hambre class
	instanceVariableNames: 'instance'!

!Hambre class methodsFor: 'as yet unclassified' stamp: 'Guidito 10/3/2012 19:51'!
instance
	instance ifNil:[instance:=super new].
	^instance.! !

!Hambre class methodsFor: 'as yet unclassified' stamp: 'Guidito 10/3/2012 19:52'!
new
	^self instance.! !

Necesidad subclass: #Sed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Granja'!

Sed class
	instanceVariableNames: 'instance'!

Sed class
	instanceVariableNames: 'instance'!

!Sed class methodsFor: 'as yet unclassified' stamp: 'Guidito 10/3/2012 19:50'!
instance
	instance ifNil:[instance:=super new].
	^instance.! !

!Sed class methodsFor: 'as yet unclassified' stamp: 'Guidito 10/3/2012 19:50'!
new
	^self instance.! !

Necesidad subclass: #Vacunar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Granja'!

Vacunar class
	instanceVariableNames: 'instance'!

Vacunar class
	instanceVariableNames: 'instance'!

!Vacunar class methodsFor: 'as yet unclassified' stamp: 'Guidito 10/3/2012 19:52'!
instance
	instance ifNil:[instance:=super new].
	^instance.! !

!Vacunar class methodsFor: 'as yet unclassified' stamp: 'Guidito 10/3/2012 19:52'!
new
	^self instance.! !
